<?php

/******************************************************************************
* AUTHOR: Josh Lewis!
* EMAIL: nocomment@joshlewis.org
* DATE: January 4th, 2005
* URL: http://blog.joshlewis.org
* 
* THIS SCRIPT IS PROVIDED BY THE AUTHOR AT NO CHARGE WITH NO WARANTEE OR GUARANTEE WHATSOEVER.
* USE THIS SCRIPT AT YOUR OWN RISK. THIS SCRIPT IS INTENDED FOR USE ONLY WITH INSTALLATIONS
* OF MOVABLE TYPE 2.X. USE OF THIS SCRIPT IMPLIES YOUR AGREEMENT THAT THE AUTHOR OF 
* THIS SCRIPT IS IN NO WAY LIABLE FOR ANY DAMAGE OR UNDESIRABLE EFFECTS THAT THIS CODE MAY CAUSE
*
* HAVING SAID THAT, JOSH THINKS IT WORKS PRETTY WELL FOR HIS NEEDS. ;-)
*******************************************************************************/

//Use UTF-8. 
header('Content-Type: text/html; charset=utf-8');

//Start a session so we can store info for use in the script
session_start();

//Store the heading so we can display the exact same one on multiple pages.
$heading = "<h1>No Comment.</h1>\n<h2>Close your comments. Make the bad man stop.</h2>\n";

//Just to seriously abstract things
$commentsOff = 2;
$commentsOn = 1;

//Turn off error reporting so the user doesn't see ugly errors. Change '0' to 'E_ALL' if you're trying to
//debug this script.
error_reporting(E_ALL);

function connectToDB($user, $password) {
	//Connect to the database. We assume we're connecting to the server the script is running on, thus "localhost"
	$link = mysql_connect("localhost", $user, $password);
	if (!$link) {
		die('Could not connect: ' . mysql_error());
	}
}

function doQuery($query) {
	//Do the query
	$result = mysql_query($query);
	if (!$result) {
		die('Invalid query: ' . mysql_error());
	}
	return $result;	//Returns if successful
}

function showBlogChoiceSelector() {
	//Set database we're connecting to
	mysql_select_db($_SESSION['databasename']);
	$result = doQuery('select blog_id, blog_name from mt_blog order by blog_name');
	
	//This is just for my convinience. It makes it much easier to tell that they're trying to
	//pass in the blog IDs without having to check for specific IDs
	?><input type="hidden" name="blog_selection" value="set" />
	<?
	
	while ($row = mysql_fetch_array($result)) {
		?><input type="checkbox" value="<? echo $row['blog_id']; ?>" name="blog_id--<? echo $row['blog_id']; ?>"> <? echo $row['blog_name']; ?><br/> <?
	}

}

function showDBChoiceSelector() {
	//Get the database names and make an XHTML input widget
	$result = doQuery('show databases');
	
	?>
	<select name="databasename">
		<?
		while ($row = mysql_fetch_row($result)) {
			?><option><? echo $row[0]; ?></option>
			<?
		}
		?>
	</select>
	<?


}

function askUserForDB() {
	global $heading;
	echo $heading;
	
	?>
		<form action="<?php echo $_SERVER["REQUEST_URI"]; ?>" method="post">
			<p>You have multiple databases in your installation of MySQL. Please select the
			database that contains your installation of Movable Type.</p>
			<? showDBChoiceSelector(); ?>
			<button style="margin-top: 20px;">Use This Database</button>
		</form>
	<?
}

function askUserForBlog() {
	global $heading;
	echo $heading;
	
	?>
		<form action="<?php echo $_SERVER["REQUEST_URI"]; ?>" method="post">
			<p>You have multiple blogs in your installation of MySQL. Please select the blog(s) you want to act upon.</p>
			<? showBlogChoiceSelector(); ?>
			<button  style="margin-top: 20px;">Close Comments On These Blogs</button>
		</form>
	<?
}


function closeComments() {
	global $commentsOff;
	global $commentsOn;
	global $heading;

	connectToDB($_SESSION['user'], $_SESSION['password']);

	//Set database we're connecting to
	mysql_select_db($_SESSION['databasename']);

	//The query. Finally.
	/**/
	$bigQuery = 'UPDATE mt_entry SET entry_allow_comments = "'.$commentsOff.'"
	WHERE entry_allow_comments = "'.$commentsOn.'"
	AND entry_blog_id IN ('.implode(",", $_SESSION['blog_selection']).')
	AND entry_created_on < "'.$_SESSION['cutoffdate'].'"';
	
	$result = doQuery($bigQuery);
	
	//Destroy all session variables. We don't want those wandering around.
	$_SESSION = array();
	session_destroy();	

	echo $heading;	//put the page heading up
	
	?><p>Comments have been closed! Thank you for helping to make the bad man stop. Please rebuild all the pages on the affected blog(s) for this change to take full effect.</p><?
}

function getDBInfo() {
	//The goal of this function is to either return nothing of the database name is already
	//in the session, pull the database name out of a post, set it automatically 
	//if there is only one database, or present the UI to select the database
	//if there are multiple databases and none are in the session or post variables
	
	//Find out if we already have the db name in the session. If so, return
	if (isset($_SESSION['databasename'])) {
		return;	//we're done.
	}

	//If the database name has just been posted, grab it, store it in the session, and return
	if (isset($_POST['databasename'])) {
		$_SESSION['databasename'] = $_POST['databasename'];
		return;
	}

	//We haven't gotten the name anywhere. Find out if it is necessary to get the name at all.

	//Get the connection started so we can ask some questions	
	connectToDB($_SESSION['user'], $_SESSION['password']);
	
	$result = doQuery('show databases');
	if (mysql_num_rows($result) == 1) {
		//There is only one database. Just use that one.
		$row = mysql_fetch_row($result);
		$_SESSION['databasename'] = $row[0];
		return;
	}

	//There are multiples and we don't yet know which one to use.
	//Ask the user. This function will catch the post next time around.
	askUserForDB();
	
	//We don't want to keep going. Only ask them for the database name and nothing more!
	exit;
}

function getBlogInfo() {
	/* The goal of this function is to either return nothing of the blog IDs are already in the
	session, pull the blog IDs out of a post, set it automatically if there is only one database, or
	present the UI to select the blogs if there are multiple blogs and none are in the session or post
	variables */
	
	//Find out if we already have the blog ids in the session. If so, return
	if (isset($_SESSION['blog_selection'])) {
		return;	//we're done.
	}

	//Get connected to the database. We'll need it for anything else
	connectToDB($_SESSION['user'], $_SESSION['password']);
	mysql_select_db($_SESSION['databasename']);


	if (!isset($_POST['blog_selection'])) {
		/* The names of the blogs to use aren't being posted, and they're not in the session. Find
		out if there is only one blog in this database, in which case we can assume we ought to use
		that one. */
	
		$result = doQuery('select blog_id from mt_blog');
		if (mysql_num_rows($result) == 1) {
			//There is only one blog. Just use that one.
			$row = mysql_fetch_row($result);
			$_SESSION['blog_selection'][] = $row[0];

			//Since we've got the session loaded up properly now, we can continue
			return;
		}
	}

	//If the blog ids have been posted, grab them, store them in the session, and go forward
	if (isset($_POST['blog_selection'])) {
		//They're passing in the blogs they want to act upon.
		
		//Get all the possible blog ids in the system
		$result = doQuery('select blog_id from mt_blog');
		while ($row = mysql_fetch_row($result)) {
			//if the blog id in question was in the post (in other words, it was selected) then add it to the array in the session!
			if (isset($_POST['blog_id--'.$row[0]])) {
				$_SESSION['blog_selection'][] = $row[0];
			}
		}
		
		//Since we've got the session loaded up properly now, we can continue
		return;
	}


	/* If we get to this point in the function, we know there are multiple blogs and we don't yet
	know which one to use. Ask the user. This function will catch their post next time around. */
	askUserForBlog();
	
	//We don't want to keep going at this point. Only ask them for the blog(s) and nothing more!

	exit;
}

function getUserInfo() {
	global $heading;
	echo $heading;	//put the page heading up

	?>
	<p>Enter the login and password for your Movable Type database and the date before which you'd like to
	close all the comments on your blog(s). Then click the "Next" button.</p>

	<form action="<?php echo $_SERVER["REQUEST_URI"]; ?>" method="post">
		<div class="question">User: <input type="text" name="user" /></div>
		<div class="question">Password: <input type="password" name="password" /></div>
		<div class="question">
			Date:
			<select name="month">
				<option value="01">January</option>
				<option value="02">February</option>
				<option value="03">March</option>
				<option value="04">April</option>
				<option value="05">May</option>
				<option value="06">June</option>
				<option value="07">July</option>
				<option value="08">August</option>
				<option value="09">September</option>
				<option value="10">October</option>
				<option value="11">November</option>
				<option value="12">December</option>
			</select>
			<select name="day">
				<option>01</option>
				<option>02</option>
				<option>03</option>
				<option>04</option>
				<option>05</option>
				<option>06</option>
				<option>07</option>
				<option>08</option>
				<option>09</option>
				<option>10</option>
				<option>11</option>
				<option>12</option>
				<option>13</option>
				<option>14</option>
				<option>15</option>
				<option>16</option>
				<option>17</option>
				<option>18</option>
				<option>19</option>
				<option>20</option>
				<option>21</option>
				<option>22</option>
				<option>23</option>
				<option>24</option>
				<option>25</option>
				<option>26</option>
				<option>27</option>
				<option>28</option>
				<option>29</option>
				<option>30</option>
				<option>31</option>
			</select>
			<select name="year">
				<option>2001</option>
				<option>2002</option>
				<option>2003</option>
				<option>2004</option>
				<option>2005</option>
			</select>
		</div>

		<button style="margin-top: 20px;">Next</button>
	</form>
	<?php

}




/*
==============================================================================================
==============================================================================================
==============================================================================================
==============================================================================================
*/

?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
		<title>No Comment.</title>
		<meta name="author" content="Josh Lewis!" />
		<meta name="Copyright" content="Copyright (c) 2004 - 2005 Josh Lewis!" />
		<style type="text/css">
			body {
				font-family: verdana, sans-serif;
				font-size: 12px;
				padding: 10px;
			}
			
			h1 {
				color: rgb(89, 79, 255);
				font-size: 30px;
				margin: 0px;
				padding: 0px;
			}
			
			h2 {
				font-weight: normal;
				color: #bbb;
				font-size: 11px;
				margin: -5px 0px 0px 1px;
				padding: 0px;
			}
		
			p {
				text-align: justify;
			}
		
			.question {
				margin-bottom: 20px;
			}
		</style>
	</head>
	<body>
		<?php
		if (count($_POST) == 0) {
			/* Either you're posting something, or you're starting from scratch. If you get in here,
			you're starting from scratch. */
			getUserInfo();
		}
		elseif (isset($_POST['user']) and isset($_POST['password']) and isset($_POST['year']) and isset($_POST['month']) and isset($_POST['day'])) {
			//Use the name and password to determine the database name if there is more than one database, and
			//the blog name if there is more than one blog.
			
			//Store the username and password in the session for later use
			$_SESSION['user'] = $_POST['user'];
			$_SESSION['password'] = $_POST['password'];

			//Format the cutoff date to get it ready for the query
			$_SESSION['cutoffdate'] = $_POST['year'] . '-' . $_POST['month'] . '-' . $_POST['day'];
		}
		
		//We need all these variables in order to continue. One of the above should've gotten them.
		if (isset($_SESSION['cutoffdate']) and
			isset($_SESSION['user']) and
			isset($_SESSION['password'])) {
			//This function either gets and stores the database info if there is only one DB, or it asks the user
			//to provide that information and halts execution of the rest of the script until that information is
			//provided.
			getDBInfo();
			
			//This function either gets and stores the blog info if there is only one blog, or it asks the user
			//to provide that information and halts execution of the rest of the script until that information is
			//provided.
			getBlogInfo();
			
			//This function can only be reached once all information has been retrieved. Comments are closed on
			//all appropriate blogs and the session is destroyed.
			closeComments();
		}

		?>
	</body>
</html>
